//
// Created by centos on 24. 1. 29..
//

#include "ipc_module.h"



bool SHM::ShmIsExist() {
    if(shmget(SHM_DEFAULT_KEY,sizeof(ProcessDir),IPC_EXCL)>=0){
        //shared mem exist
        return true;
    } else {
        return false;
    }
}

int SHM::Init(int server_pid) {
    int shm_id = shmget(SHM_DEFAULT_KEY,sizeof(ProcessDir),IPC_CREAT|0644);
    if(shm_id==-1){
        return -1;
    }
    auto* shared_memory = (ProcessDir *)shmat(shm_id,nullptr,0);
    if(shared_memory==(void*)-1){
        return -1;
    }
    shared_memory->server_pid=server_pid;
    shared_memory->msq_id=MSQ::Init();
    shared_memory->server_status=STATUS_SERVER_RUN;
    shmdt(shared_memory);
    return shm_id;
}

bool SHM::Drop() {
    if(shmctl(GetId(),IPC_RMID,nullptr)==0){
        return true;
    } else {
        return false;
    }
}

int SHM::GetId() {
    return shmget(SHM_DEFAULT_KEY,sizeof(ProcessDir),0);
}

int MSQ::Init() {
    int msg_id = msgget(MSQ_DEFAULT_KEY,IPC_CREAT|0644);
    return msg_id;
}

bool MSQ::MsqIsExist() {
    if(msgget(MSQ_DEFAULT_KEY,IPC_EXCL)>=0){
        return true;
    } else {
        return false;
    }
}

bool MSQ::Drop() {
    if(msgctl(GetId(),IPC_RMID,nullptr)==0){
        return true;
    } else {
        return false;
    }
}

int MSQ::GetId() {
    return msgget(MSQ_DEFAULT_KEY,0);
}
