//
// Created by centos on 24. 1. 29..
//

#ifndef SIMPLE_CHATTING2_IPC_H
#include "define.h"
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/msg.h>
#include <cstring>
#include <iostream>
#include <vector>
#include <map>
#define SIMPLE_CHATTING2_IPC_H


//message queue
class MSQ {
public:
    struct MsgContent{
        int status;
        std::string sender_pid;
        std::string data;
    };
    static int Init(); //return message queue id
    static bool MsqIsExist();
    static int GetId();
    static bool Drop();
};


//shared memory
class SHM {
public:
    struct ClientInfo{
        int snd_pid; //parent
        int rcv_pid; //child
        std::string name;
    };

    struct ProcessDir{
        int server_pid;
        int server_status;
        int msq_id;
        std::map<std::string,ClientInfo> user; //key = client name
    };

    static int Init(int server_pid); //return shared memory id
    static bool ShmIsExist(); //return true, false
    static int GetId();
    static bool Drop();
};


#endif //SIMPLE_CHATTING2_IPC_H
