#include <csignal>
#include <iostream>
#include <unistd.h>
#include "../function/ipc_module.h"
int StartupServer();
void ShutdownServer(int i);

int main() {
    signal(SIGINT,ShutdownServer);
    if(StartupServer()==1){
        std::cout<<"! Chatting server started !"<<std::endl;
    } else {
        std::cout<<"! Chatting server start failed !"<<std::endl;
        ShutdownServer(0);
    }
    sleep(10);
//    while(1){
//
//    }
    ShutdownServer(0);
}

void ShutdownServer(int i){
    if(!MSQ::Drop()){
        std::cout<<"Error: failed drop message queue"<<std::endl;
    }
    if(!SHM::Drop()){
        std::cout<<"Error: failed drop shared memory"<<std::endl;
    }
    std::cout<<"! Chatting server shutdown !"<<std::endl;
    exit(0);
}


int StartupServer(){
    if(SHM::ShmIsExist()==1){
        std::cout<<"Error: already server or shared memory exist"<<std::endl;
        return ERROR_SHM_ALREADY_EXIST;
    }
    if(SHM::Init(getpid())==-1){
        std::cout<<"Error: failed to Init shared memory\n"<<std::endl;
        return ERROR_SHM_CREATE_FAILED;
    }
    if(MSQ::MsqIsExist()==0){
        std::cout<<"Error: failed to create message queue"<<std::endl;
        return ERROR_MSQ_CREATE_FAILED;
    }
    return 1;
}